cbuffer cbControls:register(b0){ 
#include "../../../nodes/dx11/globalVariables.fxh"
float3 repetitionAmount <string uiname="Repetition amount";> = {5.,5.,5.};
};
#include "../../../nodes/dx11/usefulFunctions.fxh"

static const float3 goDown=float3(0,-1,0);
static const float sphereRadius=1.2+abs(sin(time)*.2);
float hollowCube(float3 pos){	
	float res= opS(sdSphere(pos+goDown,sphereRadius),sdBox(pos+goDown,1.));
	res=opU(res,sdCylinder(pos+goDown,float2(0.4,5.5)));
	res=opU(res,sdCylinder(pos+goDown,float2(1.1+sin(time)*.5,.4)));	
	res=opU(res,sdBox(pos+goDown,float3(1.8,.2,0.2)));
	return res*0.7;
}

float2 drawYourShit(float3 pos)
{	
	float2 d=999999;
	d=float2(sdPlane(pos),1.0);	
	if (cheapBox(pos,float3(20.,20.,20.))<0){
		float3 repPos=opRep(pos,repetitionAmount);//we dfine a new repetition pos
		d = opU(d,float2(hollowCube(repPos),3.));		
	}
	d=opU(d,float2(sdSphere(pos+float3(0.0,-2.0,0.0),1.),50));
	d.x=max(-sdSphere(pos-ro,2.),d.x);
	return d;	
}

#include "../../../nodes/dx11/marchingFunctions.fxh"

void colourYourShit(float m){
	if(m<1.5){ 
		col = 0.3 + 0.1*abs(fmod( floor(5.0*pos.z) + floor(5.0*pos.x), 2.0));
    }else if (m<4){
    	//Triplanar texture mapping, is great but can be expensive
    	//the last argument "1" is the uv scale
    	col=smoothTex3D(textureSampler,texColor,pos,nor,1);
    }else if (m<51){
    	//SPHERICAL UVS ARE MUCH CHEAPER!!! MAKE SURE TO USE SAME "POS" 
    	//AS CENTER OF GEOMETRY WHICH HERE IS SDSPHERE ABOVE 
    	// AND SO POS SHOULD BE "pos+float3(0.0,-2.0,0.0)"
    	//last argument "2" is the uv scale
    	col=sphericalTex3D(textureSampler,texColor,pos+float3(0.0,-2.0,0.0),2);
    }
};
void finalPassShit(){};

#include "../../../nodes/dx11/render.fxh"
technique10 raymarch_depth{
	pass P0{
		SetVertexShader(CompileShader(vs_5_0,VS()));
		SetPixelShader(CompileShader(ps_5_0,PS()));
	}
}